#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

int main(int argc, char* argv[])
{
    int world_rank, world_size, sub_comm_rank;

    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &world_size);

    int comm_color = world_rank < (world_size / 2);
    MPI_Comm sub_comm;
    MPI_Comm_split(MPI_COMM_WORLD, comm_color, world_rank, &sub_comm);
    MPI_Comm_rank(sub_comm, &sub_comm_rank);

    printf(
        "[%d] Rank in comm %d: %d\n",
        world_rank, comm_color, sub_comm_rank
    );

    MPI_Comm_free(&sub_comm);

    MPI_Finalize();

    return EXIT_SUCCESS;
}
