#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

int main(int argc, char* argv[])
{
    int rank, worldsize, hostname_len;
    char hostname[MPI_MAX_PROCESSOR_NAME];

    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &worldsize);

    MPI_Get_processor_name(hostname, &hostname_len);

    printf(
        "[%s] Hello from rank %d ( / %d processes)\n",
        hostname, rank, worldsize
    );

    MPI_Finalize();

    return EXIT_SUCCESS;
}
