#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <mpi.h>

#define NB_VALUES 15

int main(int argc, char* argv[])
{
    int rank, tag = 1;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    int* values = malloc(NB_VALUES * sizeof(int));
    memset(values, 0, NB_VALUES * sizeof(int));

    if (rank == 0)
    {
        for (int i = 0; i < NB_VALUES; i++)
        {
            values[i] = i;
        }
        MPI_Send(values, NB_VALUES, MPI_INT, 1, tag, MPI_COMM_WORLD);
    }
    else if (rank == 1)
    {
        MPI_Recv(values, NB_VALUES, MPI_INT, 0, tag, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
        printf("[%d] J'ai reçu les valeurs ", rank);
        for (int i = 0; i < NB_VALUES; i++)
        {
            printf("%d ", values[i]);
        }
        printf("\n");
    }

    free(values);

    MPI_Finalize();

    return EXIT_SUCCESS;
}
